require 'appengine-apis/datastore'

module AppEngineUtils
  module Datastore
    class Blob
      
      def create(blob)
        @blob = AppEngine::Datastore::Blob.new(blob).to_java
        entity = AppEngine::Datastore::Entity.new("Blob")
        entity['blob']=@blob
        key = AppEngine::Datastore.put(entity)
        key.to_s
      end
      
      def read(key)
        result = nil
        
        begin
          datastore_key = AppEngine::Datastore::Key.new(key)
          entity = AppEngine::Datastore.get(datastore_key)
          result = entity['blob']
        rescue AppEngine::Datastore::EntityNotFound
          result = nil 
        end
        result
        
      end
      
      def update(key,dataset)
        delete(key)
        new_key = create(dataset)
        new_key
      end
      
      def delete(key)
        datastore_key = AppEngine::Datastore::Key.new(key)
        result = AppEngine::Datastore.delete(datastore_key)
        result
      end
      
    end
  end
end